﻿using System;
using NetMQ;

namespace WeatherUpdateServer
{
    internal static class WeatherUpdateServer
    {
        private static void Main()
        {
            bool stopRequested = false;
 
            // Wire up the CTRL+C handler
            Console.CancelKeyPress += (sender, e) => stopRequested = true;

            Console.WriteLine("Publishing weather updates...");

            using (var context = NetMQContext.Create())// NetMQ全局维护的Content上下文，建议只有一个并且使用完毕后及时回收。
            using (var publisher = context.CreatePublisherSocket())// 从Content上下文中创建CreatePublisherSocket，这里如果用其他四种模式之一需要Create其他类型。
            {
                publisher.Bind("tcp://127.0.0.1:5556");// Bind到指定的IP及端口。

                var rng = new Random();

                while (!stopRequested)
                {
                    int zipcode =  rng.Next(0, 99999);// 这里模拟一个随机命令编号（如果非10001，客户端直接丢弃此Publisher发布的消息，实现消息过滤）
                    int temperature = rng.Next(-80, 135);
                    int relhumidity = rng.Next(0, 90);

                    publisher.Send(string.Format("{0} {1} {2}", zipcode, temperature, relhumidity));// 直接Send，干净整洁。
                }
            }
        }
    }
}
